// Includes
var shortPoll = require('../util/shortPoll.js').func;
var getAssetOwners = require('./getAssetOwners.js').func;
var resolveDate = require('../util/resolveDate.js').func;

// Args
exports.required = ['assetId'];
exports.optional = [];

// Define
exports.func = function (args) {
  var assetId = args.assetId;
  return shortPoll({
    getLatest: function (latest) {
      return getAssetOwners({assetId: assetId, sort: "Desc"})
      .then(function (owners) {
        var given = [];
        for (var i = owners.data.length - 1; i >= 0; i--) {
          var owner = owners.data[i];
          var id = (new Date(owner.created));
          if (id > latest) {
            latest = id;
            given.push(owner);
          }
        }
        return {
          latest: latest,
          data: given
        }
      }).catch(function() {
        return {
          latest: latest,
          data: []
        }
      });
    },
    delay: 'onAssetPurchase',
    timeout: -1
  });
};
